// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"../../../../../../../../../../aws-sdk.external":[function(require,module,exports) {
module.exports=require('aws-sdk');
},{}],"index.ts":[function(require,module,exports) {
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handler = void 0;

const aws_sdk_1 = require("aws-sdk");

const codeCommit = new aws_sdk_1.CodeCommit();

exports.handler = async event => {
  const {
    region,
    detail
  } = event;
  const shouldUpdateApprovalState = process.env.UPDATE_APPROVAL_STATE === 'TRUE';
  const shouldPostComment = process.env.POST_COMMENT === 'TRUE';
  const {
    pullRequestId,
    revisionId,
    repositoryName,
    beforeCommitId,
    afterCommitId
  } = getPullRequestProps(detail);
  const s3Prefix = region === 'us-east-1' ? 's3' : `s3-${region}`;

  switch (detail['build-status']) {
    case CodeBuildState.IN_PROGRESS:
      if (shouldUpdateApprovalState) {
        await codeCommit.updatePullRequestApprovalState({
          pullRequestId,
          revisionId,
          approvalState: 'REVOKE'
        }).promise();
      }

      if (shouldPostComment) {
        await codeCommit.postCommentForPullRequest({
          pullRequestId,
          repositoryName,
          beforeCommitId,
          afterCommitId,
          content: `** Build started at ${'time'} **`
        }).promise();
      }

      break;

    case CodeBuildState.FAILED:
      if (shouldPostComment) {
        const badge = `https://${s3Prefix}.amazonaws.com/codefactory-${region}-prod-default-build-badges/failing.svg`;
        const content = `![Failing](${badge} "Failing") - See the [Logs](${detail['additional-information'].logs['deep-link']})`;
        await codeCommit.postCommentForPullRequest({
          pullRequestId,
          repositoryName,
          beforeCommitId,
          afterCommitId,
          content
        }).promise();
      }

      break;

    case CodeBuildState.SUCCEEDED:
      if (shouldUpdateApprovalState) {
        await codeCommit.updatePullRequestApprovalState({
          pullRequestId,
          revisionId,
          approvalState: 'APPROVE'
        }).promise();
      }

      if (shouldPostComment) {
        const badge = `https://${s3Prefix}.amazonaws.com/codefactory-${region}-prod-default-build-badges/passing.svg`;
        const content = `![Passing](${badge} "Passing") - See the [Logs](${detail['additional-information'].logs['deep-link']})`;
        await codeCommit.postCommentForPullRequest({
          pullRequestId,
          repositoryName,
          beforeCommitId,
          afterCommitId,
          content
        }).promise();
      }

      break;

    case CodeBuildState.STOPPED:
      console.log('Build stopped!');
      break;

    default:
      throw new Error(`Invalid build status: ${detail['build-status']}`);
  }
};

const getPullRequestProps = detail => {
  let repositoryName;
  let pullRequestId;
  let beforeCommitId;
  let afterCommitId;
  let revisionId;
  detail['additional-information'].environment['environment-variables'].forEach(({
    name,
    value
  }) => {
    switch (name) {
      case 'pullRequestId':
        pullRequestId = value;
        break;

      case 'repositoryName':
        repositoryName = value;
        break;

      case 'sourceCommit':
        beforeCommitId = value;
        break;

      case 'destinationCommit':
        afterCommitId = value;
        break;

      case 'revisionId':
        revisionId = value;
        break;

      default:
        throw new Error(`Unknown environment variable: ${name}`);
    }
  });
  return {
    repositoryName,
    pullRequestId,
    beforeCommitId,
    afterCommitId,
    revisionId
  };
};

var CodeBuildState;

(function (CodeBuildState) {
  CodeBuildState["IN_PROGRESS"] = "IN_PROGRESS";
  CodeBuildState["SUCCEEDED"] = "SUCCEEDED";
  CodeBuildState["FAILED"] = "FAILED";
  CodeBuildState["STOPPED"] = "STOPPED";
})(CodeBuildState || (CodeBuildState = {}));
},{"aws-sdk":"../../../../../../../../../../aws-sdk.external"}]},{},["index.ts"], null)
//# sourceMappingURL=/index.js.map